﻿using System;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Web.UI;
using PdfSharp;
using PdfSharp.Pdf;
using ThinkGeo.MapSuite.Core;

namespace WebApplication1
{
    public partial class Defaul_t : System.Web.UI.Page
    {
        protected void Page_Load(object sender, EventArgs e)
        {
            if (!Page.IsPostBack)
            {
                Map1.MapUnit = GeographyUnit.Meter;
                Map1.CurrentExtent = new RectangleShape(-20037508 / 2, 20037508 / 2, 20037508 / 2, -20037508 / 2);
                BingMapsLayer worldLayer = new BingMapsLayer("Your Key");
                Map1.StaticOverlay.Layers.Add("WorldImageLayer", worldLayer);
            }
        }

        protected void btnToPdf_Click(object sender, EventArgs e)
        {
            PdfDocument document = new PdfDocument();
            PdfPage page = document.AddPage();
            if (rdlOptions.SelectedItem.Text == "Landscape")
            {
                page.Orientation = PageOrientation.Landscape;
            }
            ExtensionPdfGeoCanvas pdfGeoCanvas = new ExtensionPdfGeoCanvas();

            // This allows you to control the area in which you want the
            // map to draw in.  Leaving this commented out uses the whole page
            //pdfGeoCanvas.DrawingArea = new Rectangle(200, 50, 400, 400);
            Collection<SimpleCandidate> labelsInLayers = new Collection<SimpleCandidate>();
            foreach (Layer layer in Map1.StaticOverlay.Layers)
            {
                RectangleShape printExtent = ExtentHelper.GetDrawingExtent(Map1.CurrentExtent, (float)Map1.WidthInPixels, (float)Map1.HeightInPixels);
                pdfGeoCanvas.BeginDrawing(page, printExtent, GeographyUnit.DecimalDegree);
                layer.Open();
                layer.Draw(pdfGeoCanvas, labelsInLayers);
                layer.Close();
                pdfGeoCanvas.EndDrawing();
            }

            string filename = Server.MapPath(".") + "\\MapSuite PDF Map.pdf";
            document.Save(filename);
            OpenPdfFile(filename);
        }

        private void OpenPdfFile(string filename)
        {
            string javascriptFormat = "<script language='javascript' type='text/javascript'>{0}</script>";
            try
            {
                ClientScript.RegisterStartupScript(this.GetType(), "showPdfFile", string.Format(javascriptFormat, "function A() {window.open('MapSuite PDF Map.pdf');};A();"));
            }
            catch (Win32Exception ex)
            {
                if (ex.Message == "No application is associated with the specified file for this operation")
                {
                    ClientScript.RegisterStartupScript(this.GetType(), "showPdfFile", string.Format(javascriptFormat, "function A() {alert('Failed to generate PDF file.');};A();"));
                }
            }
        }
    }
}