﻿using System;
using System.Drawing;
using System.Drawing.Imaging;
using System.IO;
using ThinkGeo.MapSuite.Core;

namespace WebApplication1
{
    public class ExtensionPdfGeoCanvas : PdfGeoCanvas
    {
        protected override void DrawScreenImageWithoutScalingCore(GeoImage image, float centerXInScreen, float centerYInScreen, DrawingLevel drawingLevel, float xOffset, float yOffset, float rotateAngle)
        {
            double quanlity = 0.2;
            Bitmap bitmap = new Bitmap(image.GetImageStream(this));
            Bitmap tempBitmap = new Bitmap((int)Math.Ceiling(bitmap.Width * quanlity), (int)Math.Ceiling(bitmap.Height * quanlity));
            Graphics g = Graphics.FromImage(tempBitmap);
            g.DrawImage(bitmap, 0, 0, tempBitmap.Width, tempBitmap.Height);
            g.Dispose();
            Bitmap actuallyDrawingBitmap = new Bitmap(bitmap.Width, bitmap.Height);
            actuallyDrawingBitmap.SetResolution(Dpi, Dpi);
            Graphics actuallyDrawingGraphics = Graphics.FromImage(actuallyDrawingBitmap);
            actuallyDrawingGraphics.DrawImage(tempBitmap, 0, 0, bitmap.Width, bitmap.Height);
            actuallyDrawingGraphics.Dispose();
            tempBitmap.Dispose();

            MemoryStream stream = new MemoryStream();
            actuallyDrawingBitmap.Save(stream, ImageFormat.Png);
            GeoImage geoImage = new GeoImage(stream);

            base.DrawScreenImageWithoutScalingCore(geoImage, centerXInScreen, centerYInScreen, drawingLevel, xOffset, yOffset, rotateAngle);
            bitmap.Dispose();
        }
    }
}